
from torch.utils.data import DataLoader, Dataset


class CustomData(Dataset):
    def __init__(self, folder_path):
        self.folder_path = folder_path
        self.all_folders = os.listdir(self.folder_path)

    def __getitem__(self, idx):
        images = []

        choiced_folders = random.sample(self.all_folders, 5)
        for choiced_folder in choiced_folders:
            all_images = os.listdir(os.path.join(self.folder_path, choiced_folder))
            choiced_image = random.choice(all_images)
            choiced_image_path = os.path.join(self.folder_path, choiced_folder, choiced_image)
            image = Image.open(choiced_image_path)
            image = image.convert('RGB')
            images.append(np.array(image))
        images =torch.Tensor(np.array(images))
        return images

x = CustomData('E:\jupyter\my paper\RelationNetwork\datas\miniImagenet/train')
print(x[0])
y = DataLoader(x, batch_size=10)
e = iter(y)
print(next(e).shape)
